#pragma once

#include <QBrush>
#include <QPainter>

#include "../../../../../qrgui/plugins/editorPluginInterface/elementImpl.h"
#include "../../../../../qrgui/plugins/editorPluginInterface/elementRepoInterface.h"
#include "../../../../../qrgui/plugins/editorPluginInterface/labelFactoryInterface.h"
#include "../../../../../qrgui/plugins/editorPluginInterface/labelInterface.h"
#include "ports.h"

	class AbstractNode : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/AbstractNodeClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~AbstractNode() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class ClearScreen : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/ClearScreenClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~ClearScreen() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class CommentBlock : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/CommentBlockClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(200);
			contents.setHeight(100);
			ports << portFactory.createPort(QLineF(0, 0.05, 0, 0.95), false, false, false, false, 200, 100, new NonTyped());
			ports << portFactory.createPort(QLineF(0.025, 0, 0.875, 0), false, false, false, false, 200, 100, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.25, 1, 0.95), false, false, false, false, 200, 100, new NonTyped());
			ports << portFactory.createPort(QLineF(0.025, 1, 0.975, 1), false, false, false, false, 200, 100, new NonTyped());
			ports << portFactory.createPort(QLineF(0.9, 0, 1, 0.2), false, false, false, false, 200, 100, new NonTyped());
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.1, 0.2, "Comment", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~CommentBlock() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Comment"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class ControlFlow : public qReal::ElementImpl {
	public:
		void init(QRectF &, const PortFactoryInterface &, QList<PortInterface *> &,
											qReal::LabelFactoryInterface &, QList<qReal::LabelInterface *> &,
											qReal::SdfRendererInterface *, qReal::ElementRepoInterface *) {}

		void init(qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles)
		{
			title_1 = factory.createLabel(1, 0, 0, "Guard", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		virtual ~ControlFlow() {}

		qReal::ElementImpl *clone() { return nullptr; }
		void paint(QPainter *, QRectF &){}
		bool isNode() const { return false; }
		bool isResizeable() const { return true; }
		bool isContainer() const { return false; }
		bool isDividable() const { return true; }
		bool isSortingContainer() const { return false; }
		QVector<int> sizeOfForestalling() const { return QVector<int>(4, 0); }
		int sizeOfChildrenForestalling() const { return 0; }
		bool hasMovableChildren() const { return false; }
		bool minimizesToChildren() const { return false; }
		bool maximizesChildren() const { return false; }
		QStringList fromPortTypes() const
		{
			QStringList result;
			result << "NonTyped";
			return result;
		}
		QStringList toPortTypes() const
		{
			QStringList result;
			result << "NonTyped";
			return result;
		}
		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::broken;
		}
		bool createChildrenFromMenu() const { return false; }
		QList<double> border() const
		{
			QList<double> list;
			list << 0 << 0 << 0 << 0;
			return list;
		}
		int getPenWidth() const { return 1; }
		QColor getPenColor() const { return QColor(0,0,0); }
		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }
		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	protected:
		virtual void drawStartArrow(QPainter * painter) const
		{
			QBrush old = painter->brush();
			QBrush brush;
			brush.setStyle(Qt::SolidPattern);
			painter->setBrush(brush);
			painter->setBrush(old);
		}

		virtual void drawEndArrow(QPainter * painter) const
		{
			QBrush old = painter->brush();
			QBrush brush;
			brush.setStyle(Qt::SolidPattern);
			painter->setBrush(brush);
			static const QPointF points[] = {
				QPointF(-5,10),
				QPointF(0,0),
				QPointF(5,10)
			};
			painter->drawPolyline(points, 3);
			painter->setBrush(old);
		}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			title_1->setTextFromRepo(repo->logicalProperty("Guard"));
		}

	private:
		qReal::LabelInterface *title_1;
	};

	class EngineCommand : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/EngineCommandClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(-1);
			contents.setHeight(-1);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~EngineCommand() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class EngineMovementCommand : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/EngineMovementCommandClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(-1);
			contents.setHeight(-1);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~EngineMovementCommand() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class Ev3Beep : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3BeepClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1.2, -0.7, "Volume", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Volume:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1.4, 1.2, "WaitForCompletion", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Wait for Completion:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3Beep() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Volume"));
			title_2->setTextFromRepo(repo->logicalProperty("WaitForCompletion"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class Ev3ClearEncoder : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3ClearEncoderClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3ClearEncoder() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class Ev3DrawCircle : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3DrawCircleClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, 1.2, "XCoordinateCircle", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.8, "YCoordinateCircle", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 2.4, "CircleRadius", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Radius:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
			title_4 = factory.createLabel(4, 1, 3, "Filled", false, 0);
			title_4->setBackground(Qt::white);
			title_4->setScaling(false, false);
			title_4->setHard(false);
			title_4->setPrefix(QObject::tr("Filled:"));
			title_4->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_4);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3DrawCircle() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("XCoordinateCircle"));
			title_2->setTextFromRepo(repo->logicalProperty("YCoordinateCircle"));
			title_3->setTextFromRepo(repo->logicalProperty("CircleRadius"));
			title_4->setTextFromRepo(repo->logicalProperty("Filled"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
		qReal::LabelInterface *title_4;
	};

	class Ev3DrawLine : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3DrawLineClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.72, 1.2, "X1CoordinateLine", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X1:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.72, 1.8, "Y1CoordinateLine", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y1:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 0.72, 2.4, "X2CoordinateLine", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("X2:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
			title_4 = factory.createLabel(4, 0.72, 3, "Y2CoordinateLine", false, 0);
			title_4->setBackground(Qt::white);
			title_4->setScaling(false, false);
			title_4->setHard(false);
			title_4->setPrefix(QObject::tr("Y2:"));
			title_4->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_4);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3DrawLine() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("X1CoordinateLine"));
			title_2->setTextFromRepo(repo->logicalProperty("Y1CoordinateLine"));
			title_3->setTextFromRepo(repo->logicalProperty("X2CoordinateLine"));
			title_4->setTextFromRepo(repo->logicalProperty("Y2CoordinateLine"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
		qReal::LabelInterface *title_4;
	};

	class Ev3DrawPixel : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3DrawPixelClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.72, 1.2, "XCoordinatePix", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.72, 1.8, "YCoordinatePix", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3DrawPixel() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("XCoordinatePix"));
			title_2->setTextFromRepo(repo->logicalProperty("YCoordinatePix"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class Ev3DrawRect : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3DrawRectClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, 1.2, "XCoordinateRect", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.8, "YCoordinateRect", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 2.4, "WidthRect", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Width:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
			title_4 = factory.createLabel(4, 1, 3, "HeightRect", false, 0);
			title_4->setBackground(Qt::white);
			title_4->setScaling(false, false);
			title_4->setHard(false);
			title_4->setPrefix(QObject::tr("Height:"));
			title_4->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_4);
			title_5 = factory.createLabel(5, 1, 3.6, "Filled", false, 0);
			title_5->setBackground(Qt::white);
			title_5->setScaling(false, false);
			title_5->setHard(false);
			title_5->setPrefix(QObject::tr("Filled:"));
			title_5->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_5);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3DrawRect() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("XCoordinateRect"));
			title_2->setTextFromRepo(repo->logicalProperty("YCoordinateRect"));
			title_3->setTextFromRepo(repo->logicalProperty("WidthRect"));
			title_4->setTextFromRepo(repo->logicalProperty("HeightRect"));
			title_5->setTextFromRepo(repo->logicalProperty("Filled"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
		qReal::LabelInterface *title_4;
		qReal::LabelInterface *title_5;
	};

	class Ev3EngineMovementCommand : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3EngineMovementCommandClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(-1);
			contents.setHeight(-1);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3EngineMovementCommand() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class Ev3EnginesBackward : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3EnginesBackwardClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.7, 1.2, "Power", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Power:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3EnginesBackward() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
			title_2->setTextFromRepo(repo->logicalProperty("Power"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class Ev3EnginesForward : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3EnginesForwardClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.7, 1.2, "Power", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Power:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3EnginesForward() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
			title_2->setTextFromRepo(repo->logicalProperty("Power"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class Ev3EnginesStop : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3EnginesStopClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3EnginesStop() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class Ev3Led : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3LedClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.7, -0.7, "Color", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Color:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3Led() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Color"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class Ev3PlayTone : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3PlayToneClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, -0.7, "Frequency", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Frequency:"));
			title_1->setSuffix(QObject::tr("Hz"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1.2, 1.2, "Volume", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Volume:"));
			title_2->setSuffix(QObject::tr("%"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1.2, 1.8, "Duration", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Duration"));
			title_3->setSuffix(QObject::tr("ms"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
			title_4 = factory.createLabel(4, 1.2, 2.4, "WaitForCompletion", false, 0);
			title_4->setBackground(Qt::white);
			title_4->setScaling(false, false);
			title_4->setHard(false);
			title_4->setPrefix(QObject::tr("Wait for Completion:"));
			title_4->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_4);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3PlayTone() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Frequency"));
			title_2->setTextFromRepo(repo->logicalProperty("Volume"));
			title_3->setTextFromRepo(repo->logicalProperty("Duration"));
			title_4->setTextFromRepo(repo->logicalProperty("WaitForCompletion"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
		qReal::LabelInterface *title_4;
	};

	class Ev3SensorBlock : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3SensorBlockClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(-1);
			contents.setHeight(-1);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3SensorBlock() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class Ev3WaitForButton : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3WaitForButtonClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, 1.2, "Button", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Button:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3WaitForButton() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Button"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class Ev3WaitForColor : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3WaitForColorClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.74, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.74, 1.2, "Color", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Color:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3WaitForColor() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Color"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class Ev3WaitForColorIntensity : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3WaitForColorIntensityClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1.1, 1.2, "Intensity", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Intensity:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1.1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3WaitForColorIntensity() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Intensity"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class Ev3WaitForEncoder : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3WaitForEncoderClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.8, 1.2, "TachoLimit", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Tacho Limit:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 0.8, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3WaitForEncoder() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("TachoLimit"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class Ev3WaitForLight : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3WaitForLightClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.9, 1.2, "Percents", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Percents:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3WaitForLight() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Percents"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class Ev3WaitForSonarDistance : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3WaitForSonarDistanceClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.2, "Distance", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Distance:"));
			title_2->setSuffix(QObject::tr("cm"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1.1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3WaitForSonarDistance() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Distance"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class Ev3WaitForSound : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3WaitForSoundClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.2, "Volume", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Volume:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3WaitForSound() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Volume"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class Ev3WaitForTouchSensor : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/Ev3WaitForTouchSensorClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Ev3WaitForTouchSensor() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class FiBlock : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/FiBlockClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~FiBlock() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class FinalNode : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/FinalNodeClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~FinalNode() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class Fork : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/ForkClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Fork() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class Function : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/FunctionClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.6, 1.2, "Body", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Body:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Function() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Body"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class GetButtonCode : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/GetButtonCodeClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.6, 1.2, "Variable", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Variable:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.6, 1.8, "Wait", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(true);
			title_2->setPrefix(QObject::tr("Wait:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~GetButtonCode() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Variable"));
			title_2->setTextFromRepo(repo->logicalProperty("Wait"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class IfBlock : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/IfBlockClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, 1.2, "Condition", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Condition:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~IfBlock() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Condition"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class InitialNode : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/InitialNodeClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~InitialNode() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class Join : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/JoinClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Join() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class KillThread : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/KillThreadClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.6, 1.2, "Thread", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Thread:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~KillThread() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Thread"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class Loop : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/LoopClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Iterations", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Iterations:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Loop() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Iterations"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class MarkerDown : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/MarkerDownClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.54, -0.7, "Color", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Color:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~MarkerDown() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Color"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class MarkerUp : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/MarkerUpClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~MarkerUp() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class NxtBeep : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtBeepClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1.2, -0.7, "Volume", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Volume:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1.4, 1.2, "WaitForCompletion", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Wait for Completion:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtBeep() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Volume"));
			title_2->setTextFromRepo(repo->logicalProperty("WaitForCompletion"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class NxtClearEncoder : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtClearEncoderClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtClearEncoder() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class NxtDrawCircle : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtDrawCircleClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, 1.2, "XCoordinateCircle", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.8, "YCoordinateCircle", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 2.4, "CircleRadius", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Radius:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtDrawCircle() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("XCoordinateCircle"));
			title_2->setTextFromRepo(repo->logicalProperty("YCoordinateCircle"));
			title_3->setTextFromRepo(repo->logicalProperty("CircleRadius"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class NxtDrawLine : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtDrawLineClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.72, 1.2, "X1CoordinateLine", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X1:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.72, 1.8, "Y1CoordinateLine", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y1:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 0.72, 2.4, "X2CoordinateLine", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("X2:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
			title_4 = factory.createLabel(4, 0.72, 3, "Y2CoordinateLine", false, 0);
			title_4->setBackground(Qt::white);
			title_4->setScaling(false, false);
			title_4->setHard(false);
			title_4->setPrefix(QObject::tr("Y2:"));
			title_4->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_4);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtDrawLine() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("X1CoordinateLine"));
			title_2->setTextFromRepo(repo->logicalProperty("Y1CoordinateLine"));
			title_3->setTextFromRepo(repo->logicalProperty("X2CoordinateLine"));
			title_4->setTextFromRepo(repo->logicalProperty("Y2CoordinateLine"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
		qReal::LabelInterface *title_4;
	};

	class NxtDrawPixel : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtDrawPixelClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.72, 1.2, "XCoordinatePix", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.72, 1.8, "YCoordinatePix", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtDrawPixel() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("XCoordinatePix"));
			title_2->setTextFromRepo(repo->logicalProperty("YCoordinatePix"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class NxtDrawRect : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtDrawRectClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, 1.2, "XCoordinateRect", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.8, "YCoordinateRect", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 2.4, "WidthRect", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Width:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
			title_4 = factory.createLabel(4, 1, 3, "HeightRect", false, 0);
			title_4->setBackground(Qt::white);
			title_4->setScaling(false, false);
			title_4->setHard(false);
			title_4->setPrefix(QObject::tr("Height:"));
			title_4->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_4);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtDrawRect() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("XCoordinateRect"));
			title_2->setTextFromRepo(repo->logicalProperty("YCoordinateRect"));
			title_3->setTextFromRepo(repo->logicalProperty("WidthRect"));
			title_4->setTextFromRepo(repo->logicalProperty("HeightRect"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
		qReal::LabelInterface *title_4;
	};

	class NxtEngineMovementCommand : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtEngineMovementCommandClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(-1);
			contents.setHeight(-1);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtEngineMovementCommand() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class NxtEnginesBackward : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtEnginesBackwardClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.7, 1.2, "Power", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Power:"));
			title_2->setSuffix(QObject::tr("%"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtEnginesBackward() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
			title_2->setTextFromRepo(repo->logicalProperty("Power"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class NxtEnginesForward : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtEnginesForwardClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.7, 1.2, "Power", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Power:"));
			title_2->setSuffix(QObject::tr("%"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtEnginesForward() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
			title_2->setTextFromRepo(repo->logicalProperty("Power"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return true;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class NxtEnginesStop : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtEnginesStopClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtEnginesStop() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class NxtPlayTone : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtPlayToneClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, -0.7, "Frequency", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Frequency:"));
			title_1->setSuffix(QObject::tr("Hz"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1.2, 1.2, "Volume", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Volume:"));
			title_2->setSuffix(QObject::tr("%"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1.2, 1.8, "Duration", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Duration"));
			title_3->setSuffix(QObject::tr("ms"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
			title_4 = factory.createLabel(4, 1.2, 2.4, "WaitForCompletion", false, 0);
			title_4->setBackground(Qt::white);
			title_4->setScaling(false, false);
			title_4->setHard(false);
			title_4->setPrefix(QObject::tr("Wait for Completion:"));
			title_4->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_4);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtPlayTone() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Frequency"));
			title_2->setTextFromRepo(repo->logicalProperty("Volume"));
			title_3->setTextFromRepo(repo->logicalProperty("Duration"));
			title_4->setTextFromRepo(repo->logicalProperty("WaitForCompletion"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
		qReal::LabelInterface *title_4;
	};

	class NxtSensorBlock : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtSensorBlockClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(-1);
			contents.setHeight(-1);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtSensorBlock() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class NxtWaitForButton : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtWaitForButtonClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, 1.2, "Button", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Button:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtWaitForButton() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Button"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class NxtWaitForColor : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtWaitForColorClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.74, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.74, 1.2, "Color", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Color:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtWaitForColor() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Color"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class NxtWaitForColorIntensity : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtWaitForColorIntensityClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1.1, 1.2, "Intensity", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Intensity:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1.1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtWaitForColorIntensity() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Intensity"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class NxtWaitForEncoder : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtWaitForEncoderClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.8, 1.2, "TachoLimit", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Tacho Limit:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 0.8, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtWaitForEncoder() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("TachoLimit"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class NxtWaitForLight : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtWaitForLightClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.9, 1.2, "Percents", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Percents:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtWaitForLight() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Percents"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class NxtWaitForSonarDistance : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtWaitForSonarDistanceClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.2, "Distance", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Distance:"));
			title_2->setSuffix(QObject::tr("cm"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtWaitForSonarDistance() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Distance"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class NxtWaitForSound : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtWaitForSoundClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.2, "Volume", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Volume:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtWaitForSound() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Volume"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class NxtWaitForTouchSensor : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/NxtWaitForTouchSensorClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~NxtWaitForTouchSensor() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class PrintText : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/PrintTextClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, 1.2, "XCoordinateText", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.8, "YCoordinateText", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 2.4, "PrintText", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Text:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~PrintText() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("XCoordinateText"));
			title_2->setTextFromRepo(repo->logicalProperty("YCoordinateText"));
			title_3->setTextFromRepo(repo->logicalProperty("PrintText"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class Randomizer : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/RandomizerClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.6, 1.2, "Variable", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Variable:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.6, 1.8, "LowerBound", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("From:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 0.6, 2.4, "UpperBound", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("To:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Randomizer() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Variable"));
			title_2->setTextFromRepo(repo->logicalProperty("LowerBound"));
			title_3->setTextFromRepo(repo->logicalProperty("UpperBound"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class ReceiveMessageThreads : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/ReceiveMessageThreadsClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.6, 1.2, "Variable", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Variable:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.6, 1.8, "Synchronized", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Synchronized:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~ReceiveMessageThreads() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Variable"));
			title_2->setTextFromRepo(repo->logicalProperty("Synchronized"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class RobotsDiagramNode : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/RobotsDiagramNodeClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(204);
			contents.setHeight(204);
			ports << portFactory.createPort(QPointF(0.00980392, 0.5), false, false, 204, 204, new NonTyped());
			ports << portFactory.createPort(QPointF(0.5, 0.00980392), false, false, 204, 204, new NonTyped());
			ports << portFactory.createPort(QPointF(0.990196, 0.5), false, false, 204, 204, new NonTyped());
			ports << portFactory.createPort(QPointF(0.5, 0.990196), false, false, 204, 204, new NonTyped());
			title_1 = factory.createLabel(1, 0.205882, 0.0588235, "name", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~RobotsDiagramNode() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->name());
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return true;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class SendMessageThreads : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/SendMessageThreadsClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.6, 1.2, "Thread", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Thread:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.6, 1.8, "Message", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Message:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~SendMessageThreads() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Thread"));
			title_2->setTextFromRepo(repo->logicalProperty("Message"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class Subprogram : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/SubprogramClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, -0.4, -0.7, "name", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Subprogram() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->name());
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class SubprogramDiagram : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/SubprogramDiagramClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(204);
			contents.setHeight(204);
			ports << portFactory.createPort(QPointF(0.00980392, 0.5), false, false, 204, 204, new NonTyped());
			ports << portFactory.createPort(QPointF(0.5, 0.00980392), false, false, 204, 204, new NonTyped());
			ports << portFactory.createPort(QPointF(0.990196, 0.5), false, false, 204, 204, new NonTyped());
			ports << portFactory.createPort(QPointF(0.5, 0.990196), false, false, 204, 204, new NonTyped());
			title_1 = factory.createLabel(1, 0.205882, 0.0588235, "name", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~SubprogramDiagram() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->name());
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return true;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class SwitchBlock : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/SwitchBlockClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, 1.2, "Expression", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Expression:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~SwitchBlock() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Expression"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class Timer : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TimerClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.6, -0.7, "Delay", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Delay:"));
			title_1->setSuffix(QObject::tr("ms"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~Timer() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Delay"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikAnalogSensorBlock : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikAnalogSensorBlockClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(-1);
			contents.setHeight(-1);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikAnalogSensorBlock() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class TrikAngularServo : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikAngularServoClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.7, 1.2, "Power", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Angle:"));
			title_2->setSuffix(QObject::tr("°"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikAngularServo() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
			title_2->setTextFromRepo(repo->logicalProperty("Power"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikDetect : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikDetectClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Mode", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Mode:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, -0.5, 1.2, QObject::tr("Detect by Videocamera"), 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikDetect() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Mode"));
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikDetectorToVariable : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikDetectorToVariableClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, -0.3, 1.2, QObject::tr("Line Detector into Variable"), 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.8, 1.8, "Variable", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Variable:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikDetectorToVariable() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
			title_2->setTextFromRepo(repo->logicalProperty("Variable"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikDigitalSensorBlock : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikDigitalSensorBlockClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(-1);
			contents.setHeight(-1);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikDigitalSensorBlock() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class TrikDrawArc : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikDrawArcClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, 1.2, "XCoordinateArc", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.8, "YCoordinateArc", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 2.4, "WidthArc", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Width:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
			title_4 = factory.createLabel(4, 1, 3, "HeightArc", false, 0);
			title_4->setBackground(Qt::white);
			title_4->setScaling(false, false);
			title_4->setHard(false);
			title_4->setPrefix(QObject::tr("Height:"));
			title_4->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_4);
			title_5 = factory.createLabel(5, 1, 3.6, "StartAngle", false, 0);
			title_5->setBackground(Qt::white);
			title_5->setScaling(false, false);
			title_5->setHard(false);
			title_5->setPrefix(QObject::tr("Start Angle:"));
			title_5->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_5);
			title_6 = factory.createLabel(6, 1, 4.2, "SpanAngle", false, 0);
			title_6->setBackground(Qt::white);
			title_6->setScaling(false, false);
			title_6->setHard(false);
			title_6->setPrefix(QObject::tr("Span Angle:"));
			title_6->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_6);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikDrawArc() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("XCoordinateArc"));
			title_2->setTextFromRepo(repo->logicalProperty("YCoordinateArc"));
			title_3->setTextFromRepo(repo->logicalProperty("WidthArc"));
			title_4->setTextFromRepo(repo->logicalProperty("HeightArc"));
			title_5->setTextFromRepo(repo->logicalProperty("StartAngle"));
			title_6->setTextFromRepo(repo->logicalProperty("SpanAngle"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
		qReal::LabelInterface *title_4;
		qReal::LabelInterface *title_5;
		qReal::LabelInterface *title_6;
	};

	class TrikDrawEllipse : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikDrawEllipseClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, 1.2, "XCoordinateEllipse", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.8, "YCoordinateEllipse", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 2.4, "WidthEllipse", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Width:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
			title_4 = factory.createLabel(4, 1, 3, "HeightEllipse", false, 0);
			title_4->setBackground(Qt::white);
			title_4->setScaling(false, false);
			title_4->setHard(false);
			title_4->setPrefix(QObject::tr("Height:"));
			title_4->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_4);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikDrawEllipse() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("XCoordinateEllipse"));
			title_2->setTextFromRepo(repo->logicalProperty("YCoordinateEllipse"));
			title_3->setTextFromRepo(repo->logicalProperty("WidthEllipse"));
			title_4->setTextFromRepo(repo->logicalProperty("HeightEllipse"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
		qReal::LabelInterface *title_4;
	};

	class TrikDrawLine : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikDrawLineClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.72, 1.2, "X1CoordinateLine", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X1:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.72, 1.8, "Y1CoordinateLine", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y1:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 0.72, 2.4, "X2CoordinateLine", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("X2:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
			title_4 = factory.createLabel(4, 0.72, 3, "Y2CoordinateLine", false, 0);
			title_4->setBackground(Qt::white);
			title_4->setScaling(false, false);
			title_4->setHard(false);
			title_4->setPrefix(QObject::tr("Y2:"));
			title_4->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_4);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikDrawLine() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("X1CoordinateLine"));
			title_2->setTextFromRepo(repo->logicalProperty("Y1CoordinateLine"));
			title_3->setTextFromRepo(repo->logicalProperty("X2CoordinateLine"));
			title_4->setTextFromRepo(repo->logicalProperty("Y2CoordinateLine"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
		qReal::LabelInterface *title_4;
	};

	class TrikDrawPixel : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikDrawPixelClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.72, 1.2, "XCoordinatePix", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.72, 1.8, "YCoordinatePix", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikDrawPixel() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("XCoordinatePix"));
			title_2->setTextFromRepo(repo->logicalProperty("YCoordinatePix"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikDrawRect : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikDrawRectClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, 1.2, "XCoordinateRect", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("X:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.8, "YCoordinateRect", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Y:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 2.4, "WidthRect", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Width:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
			title_4 = factory.createLabel(4, 1, 3, "HeightRect", false, 0);
			title_4->setBackground(Qt::white);
			title_4->setScaling(false, false);
			title_4->setHard(false);
			title_4->setPrefix(QObject::tr("Height:"));
			title_4->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_4);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikDrawRect() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("XCoordinateRect"));
			title_2->setTextFromRepo(repo->logicalProperty("YCoordinateRect"));
			title_3->setTextFromRepo(repo->logicalProperty("WidthRect"));
			title_4->setTextFromRepo(repo->logicalProperty("HeightRect"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
		qReal::LabelInterface *title_4;
	};

	class TrikInitCamera : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikInitCameraClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Mode", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Mode:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, -0.5, 1.2, QObject::tr("Initialize Videocamera"), 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikInitCamera() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Mode"));
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikInitVideoStreaming : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikInitVideoStreamingClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, -0.5, 1.2, QObject::tr("Enable Video Streaming"), 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikInitVideoStreaming() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikLed : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikLedClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.7, -0.7, "Color", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Color:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikLed() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Color"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikPlayTone : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikPlayToneClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, -0.7, "FileName", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("File name:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikPlayTone() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("FileName"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikRemoveFile : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikRemoveFileClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.66, 1.2, "File", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("File:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikRemoveFile() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("File"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikSadSmile : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikSadSmileClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikSadSmile() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class TrikSay : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikSayClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.7, -0.7, "Text", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Text:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikSay() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Text"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikSendMessage : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikSendMessageClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.9, 1.2, "Message", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Message:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.9, 1.8, "HullNumber", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Hull number:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikSendMessage() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Message"));
			title_2->setTextFromRepo(repo->logicalProperty("HullNumber"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikSensorBlock : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikSensorBlockClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(-1);
			contents.setHeight(-1);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikSensorBlock() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class TrikSetBackground : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikSetBackgroundClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.7, -0.7, "Color", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Color:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikSetBackground() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Color"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikSetPainterColor : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikSetPainterColorClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Color", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Color:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikSetPainterColor() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Color"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikSetPainterWidth : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikSetPainterWidthClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, -0.7, "Width", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Width:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikSetPainterWidth() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Width"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikSmile : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikSmileClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikSmile() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class TrikSystem : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikSystemClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, 1.2, "Command", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Command:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikSystem() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Command"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikV62AngularServo : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikV62AngularServoClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.7, 1.2, "Power", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Angle:"));
			title_2->setSuffix(QObject::tr("°"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikV62AngularServo() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
			title_2->setTextFromRepo(repo->logicalProperty("Power"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikV62ClearEncoder : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikV62ClearEncoderClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikV62ClearEncoder() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikV62WaitForEncoder : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikV62WaitForEncoderClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.8, 1.2, "TachoLimit", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Tacho Limit:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 0.8, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikV62WaitForEncoder() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("TachoLimit"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class TrikV6ClearEncoder : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikV6ClearEncoderClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikV6ClearEncoder() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikV6EngineMovementCommand : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			Q_UNUSED(titles);
			Q_UNUSED(factory);
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikV6EngineMovementCommandClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(-1);
			contents.setHeight(-1);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikV6EngineMovementCommand() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return true;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
	};

	class TrikV6EnginesBackward : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikV6EnginesBackwardClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.7, 1.2, "Power", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Power:"));
			title_2->setSuffix(QObject::tr("%"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikV6EnginesBackward() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
			title_2->setTextFromRepo(repo->logicalProperty("Power"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikV6EnginesForward : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikV6EnginesForwardClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.7, 1.2, "Power", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Power:"));
			title_2->setSuffix(QObject::tr("%"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikV6EnginesForward() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
			title_2->setTextFromRepo(repo->logicalProperty("Power"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikV6EnginesStop : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikV6EnginesStopClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.5, -0.7, "Ports", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Ports:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikV6EnginesStop() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Ports"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikWaitForAccelerometer : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitForAccelerometerClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, 1.2, "Acceleration", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Acceleration:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.8, "Sign", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Sign:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 2.4, "AccelerationAxis", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Axis:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitForAccelerometer() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Acceleration"));
			title_2->setTextFromRepo(repo->logicalProperty("Sign"));
			title_3->setTextFromRepo(repo->logicalProperty("AccelerationAxis"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class TrikWaitForButton : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitForButtonClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, 1.2, "Button", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Button:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitForButton() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Button"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikWaitForEncoder : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitForEncoderClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.8, 1.2, "TachoLimit", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Tacho Limit:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 0.8, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitForEncoder() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("TachoLimit"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class TrikWaitForGyroscope : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitForGyroscopeClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1.1, 1.2, "Degrees", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Degrees/sec:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1.1, 1.8, "Sign", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Sign:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitForGyroscope() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Degrees"));
			title_2->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikWaitForIRDistance : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitForIRDistanceClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1.1, 1.2, "Distance", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Distance:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1.1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitForIRDistance() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Distance"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class TrikWaitForLight : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitForLightClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.9, 1.2, "Percents", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Percents:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitForLight() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Percents"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class TrikWaitForMessage : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitForMessageClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 1, 1.2, "Variable", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Variable:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, 1.8, "Synchronized", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Synchronized:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitForMessage() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Variable"));
			title_2->setTextFromRepo(repo->logicalProperty("Synchronized"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikWaitForMotion : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitForMotionClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, QObject::tr("F1"), 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitForMotion() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikWaitForSonarDistance : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitForSonarDistanceClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1.1, 1.2, "Distance", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Distance:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1.1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitForSonarDistance() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
			title_2->setTextFromRepo(repo->logicalProperty("Distance"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class TrikWaitForTouchSensor : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitForTouchSensorClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.8, -0.7, "Port", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setPrefix(QObject::tr("Port:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitForTouchSensor() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("Port"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikWaitGamepadButton : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitGamepadButtonClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, -0.7, 1.2, QObject::tr("Wait gamepad button"), 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, -0.7, "Button", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(true);
			title_2->setPrefix(QObject::tr("Button:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitGamepadButton() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
			title_2->setTextFromRepo(repo->logicalProperty("Button"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikWaitGamepadConnect : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitGamepadConnectClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, -1.4, -0.7, QObject::tr("Wait for Gamepad Connect"), 0);
			title_1->setBackground(Qt::transparent);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitGamepadConnect() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikWaitGamepadDisconnect : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitGamepadDisconnectClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, -1.4, -0.7, QObject::tr("Wait for Gamepad Disconnect"), 0);
			title_1->setBackground(Qt::transparent);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitGamepadDisconnect() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
	};

	class TrikWaitGamepadWheel : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitGamepadWheelClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, -1.4, -0.7, QObject::tr("Wait for Gamepad Wheel"), 0);
			title_1->setBackground(Qt::transparent);
			title_1->setScaling(false, false);
			title_1->setHard(true);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1.1, 1.2, "Angle", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Angle:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
			title_3 = factory.createLabel(3, 1.1, 1.8, "Sign", false, 0);
			title_3->setBackground(Qt::white);
			title_3->setScaling(false, false);
			title_3->setHard(false);
			title_3->setPrefix(QObject::tr("Sign:"));
			title_3->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_3);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitGamepadWheel() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
			title_2->setTextFromRepo(repo->logicalProperty("Angle"));
			title_3->setTextFromRepo(repo->logicalProperty("Sign"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
		qReal::LabelInterface *title_3;
	};

	class TrikWaitPadPress : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWaitPadPressClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, -0.4, 1.2, QObject::tr("Wait pad press"), 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 1, -0.7, "Pad", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(true);
			title_2->setPrefix(QObject::tr("Pad:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWaitPadPress() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			Q_UNUSED(repo);
			title_2->setTextFromRepo(repo->logicalProperty("Pad"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class TrikWriteToFile : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/TrikWriteToFileClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.66, 1.2, "File", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("File:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.66, 1.8, "Text", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Text:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~TrikWriteToFile() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("File"));
			title_2->setTextFromRepo(repo->logicalProperty("Text"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

	class VariableInit : public qReal::ElementImpl
	{
	public:
		void init(qReal::LabelFactoryInterface &, QList<qReal::LabelInterface*> &) {}

		void init(QRectF &contents, const PortFactoryInterface &portFactory, QList<PortInterface *> &ports
							, qReal::LabelFactoryInterface &factory, QList<qReal::LabelInterface*> &titles
							, qReal::SdfRendererInterface *renderer, qReal::ElementRepoInterface *elementRepo)
		{
			mRenderer = renderer;
			mRenderer->load(QString(":/generated/shapes/VariableInitClass.sdf"));
			mRenderer->setElementRepo(elementRepo);
			contents.setWidth(50);
			contents.setHeight(50);
			ports << portFactory.createPort(QLineF(0, 0.1, 0, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 0, 0.9, 0), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(1, 0.1, 1, 0.9), false, false, false, false, 50, 50, new NonTyped());
			ports << portFactory.createPort(QLineF(0.1, 1, 0.9, 1), false, false, false, false, 50, 50, new NonTyped());
			title_1 = factory.createLabel(1, 0.66, 1.2, "variable", false, 0);
			title_1->setBackground(Qt::white);
			title_1->setScaling(false, false);
			title_1->setHard(false);
			title_1->setPrefix(QObject::tr("Variable:"));
			title_1->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_1);
			title_2 = factory.createLabel(2, 0.66, 1.8, "value", false, 0);
			title_2->setBackground(Qt::white);
			title_2->setScaling(false, false);
			title_2->setHard(false);
			title_2->setPrefix(QObject::tr("Value:"));
			title_2->setTextInteractionFlags(Qt::NoTextInteraction);
			titles.append(title_2);
		}

		 qReal::ElementImpl *clone() { return nullptr; }
		~VariableInit() {}

		void paint(QPainter *painter, QRectF &contents)
		{
			mRenderer->render(painter, contents);
		}

		Qt::PenStyle getPenStyle() const { return Qt::SolidLine; }

		int getPenWidth() const { return 0; }

		QColor getPenColor() const { return QColor(); }

		void drawStartArrow(QPainter *) const {}
		void drawEndArrow(QPainter *) const {}

		void updateData(qReal::ElementRepoInterface *repo) const
		{
			mRenderer->setElementRepo(repo);
			title_1->setTextFromRepo(repo->logicalProperty("variable"));
			title_2->setTextFromRepo(repo->logicalProperty("value"));
		}

		bool isNode() const
		{
			return true;
		}

		bool isResizeable() const
		{
			return false;
		}

		bool isContainer() const
		{
			return false;
		}

		bool isSortingContainer() const
		{
			return false;
		}

		QVector<int> sizeOfForestalling() const
		{
			QVector<int> result;
			result << 0 << 0 << 0 << 0;
;
			return result;
		}

		int sizeOfChildrenForestalling() const
		{
			return 0;
		}

		bool hasMovableChildren() const
		{
			return true;
		}

		bool minimizesToChildren() const
		{
			return false;
		}

		bool maximizesChildren() const
		{
			return false;
		}

		bool isDividable() const
		{
			return false;
		}

		QStringList fromPortTypes() const
		{
			return QStringList("NonTyped");
		}

		QStringList toPortTypes() const
		{
			return QStringList("NonTyped");
		}

		enums::linkShape::LinkShape shapeType() const
		{
			return enums::linkShape::square;
		}

		bool createChildrenFromMenu() const
		{
			return false;
		}

		QList<double> border() const
		{
			QList<double> list;
			return list;
		}

		QStringList bonusContextMenuFields() const
		{
			return QStringList();
		}

	private:
		qReal::SdfRendererInterface *mRenderer;
		qReal::LabelInterface *title_1;
		qReal::LabelInterface *title_2;
	};

